package com.mysql.jdbc;

import com.mysql.jdbc.profiler.ProfileEventSink;
import com.mysql.jdbc.profiler.ProfilerEvent;
import java.sql.BatchUpdateException;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.SQLWarning;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.TimerTask;

/* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/StatementImpl.class */
public class StatementImpl implements Statement {
    protected static int statementCounter = 1;
    public static final byte USES_VARIABLES_FALSE = 0;
    public static final byte USES_VARIABLES_TRUE = 1;
    public static final byte USES_VARIABLES_UNKNOWN = -1;
    protected List batchedArgs;
    protected SingleByteCharsetConverter charConverter;
    protected String charEncoding;
    protected ConnectionImpl connection;
    protected long connectionId;
    protected String currentCatalog;
    protected ProfileEventSink eventSink;
    protected int maxFieldSize;
    protected boolean pedantic;
    protected Throwable pointOfOrigin;
    protected boolean profileSQL;
    protected int statementId;
    protected boolean useUsageAdvisor;
    protected boolean continueBatchOnError;
    protected Object cancelTimeoutMutex = new Object();
    protected boolean wasCancelled = false;
    protected boolean doEscapeProcessing = true;
    private int fetchSize = 0;
    protected boolean isClosed = false;
    protected long lastInsertId = -1;
    protected int maxRows = -1;
    protected boolean maxRowsChanged = false;
    protected List openResults = new ArrayList();
    protected ResultSetInternalMethods results = null;
    protected int resultSetConcurrency = 0;
    protected int resultSetType = 0;
    protected int timeoutInMillis = 0;
    protected long updateCount = -1;
    protected SQLWarning warningChain = null;
    protected boolean holdResultsOpenOverClose = false;
    protected ArrayList batchedGeneratedKeys = null;
    protected boolean retrieveGeneratedKeys = false;
    private int originalResultSetType = 0;
    private int originalFetchSize = 0;
    private boolean isPoolable = true;

    /* JADX INFO: Access modifiers changed from: package-private */
    /* loaded from: com_mysql_jdbc.jar:com/mysql/jdbc/StatementImpl$CancelTask.class */
    public class CancelTask extends TimerTask {
        long connectionId;
        SQLException caughtWhileCancelling = null;
        private final StatementImpl this$0;

        static StatementImpl access$000(CancelTask x0) {
            return x0.this$0;
        }

        /* JADX INFO: Access modifiers changed from: package-private */
        public CancelTask(StatementImpl this$0) throws SQLException {
            this.this$0 = this$0;
            this.connectionId = 0L;
            this.connectionId = this$0.connection.getIO().getThreadId();
        }

        @Override // java.util.TimerTask, java.lang.Runnable
        public void run() {
            Thread cancelThread = new Thread(this) { // from class: com.mysql.jdbc.StatementImpl.1
                private final CancelTask this$1;

                {
                    this.this$1 = this;
                }

                /*  JADX ERROR: JadxRuntimeException in pass: BlockProcessor
                    jadx.core.utils.exceptions.JadxRuntimeException: Unreachable block: B:13:0x00ac
                    	at jadx.core.dex.visitors.blocks.BlockProcessor.checkForUnreachableBlocks(BlockProcessor.java:88)
                    	at jadx.core.dex.visitors.blocks.BlockProcessor.processBlocksTree(BlockProcessor.java:52)
                    	at jadx.core.dex.visitors.blocks.BlockProcessor.visit(BlockProcessor.java:44)
                    */
                @Override // java.lang.Thread, java.lang.Runnable
                public void run() {
                    /*
                        r5 = this;
                        r0 = 0
                        r6 = r0
                        r0 = 0
                        r7 = r0
                        r0 = r5
                        com.mysql.jdbc.StatementImpl$CancelTask r0 = r0.this$1     // Catch: java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        com.mysql.jdbc.StatementImpl r0 = com.mysql.jdbc.StatementImpl.CancelTask.access$000(r0)     // Catch: java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        java.lang.Object r0 = r0.cancelTimeoutMutex     // Catch: java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r1 = r0
                        r8 = r1
                        monitor-enter(r0)     // Catch: java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r0 = r5
                        com.mysql.jdbc.StatementImpl$CancelTask r0 = r0.this$1     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        com.mysql.jdbc.StatementImpl r0 = com.mysql.jdbc.StatementImpl.CancelTask.access$000(r0)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        com.mysql.jdbc.ConnectionImpl r0 = r0.connection     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        com.mysql.jdbc.Connection r0 = r0.duplicate()     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r6 = r0
                        r0 = r6
                        java.sql.Statement r0 = r0.createStatement()     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r7 = r0
                        r0 = r7
                        java.lang.StringBuffer r1 = new java.lang.StringBuffer     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r2 = r1
                        r2.<init>()     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        java.lang.String r2 = "KILL QUERY "
                        java.lang.StringBuffer r1 = r1.append(r2)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r2 = r5
                        com.mysql.jdbc.StatementImpl$CancelTask r2 = r2.this$1     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        long r2 = r2.connectionId     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        java.lang.StringBuffer r1 = r1.append(r2)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        java.lang.String r1 = r1.toString()     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        boolean r0 = r0.execute(r1)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r0 = r5
                        com.mysql.jdbc.StatementImpl$CancelTask r0 = r0.this$1     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        com.mysql.jdbc.StatementImpl r0 = com.mysql.jdbc.StatementImpl.CancelTask.access$000(r0)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r1 = 1
                        r0.wasCancelled = r1     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r0 = r8
                        monitor-exit(r0)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        goto L5d
                    L56:
                        r9 = move-exception
                        r0 = r8
                        monitor-exit(r0)     // Catch: java.lang.Throwable -> L56 java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                        r0 = r9
                        throw r0     // Catch: java.sql.SQLException -> L63 java.lang.NullPointerException -> L72 java.lang.Throwable -> L79
                    L5d:
                        r0 = jsr -> L81
                    L60:
                        goto Lbd
                    L63:
                        r8 = move-exception
                        r0 = r5
                        com.mysql.jdbc.StatementImpl$CancelTask r0 = r0.this$1     // Catch: java.lang.Throwable -> L79
                        r1 = r8
                        r0.caughtWhileCancelling = r1     // Catch: java.lang.Throwable -> L79
                        r0 = jsr -> L81
                    L6f:
                        goto Lbd
                    L72:
                        r8 = move-exception
                        r0 = jsr -> L81
                    L76:
                        goto Lbd
                    L79:
                        r10 = move-exception
                        r0 = jsr -> L81
                    L7e:
                        r1 = r10
                        throw r1
                    L81:
                        r11 = r0
                        r0 = r7
                        if (r0 == 0) goto L9f
                        r0 = r7
                        r0.close()     // Catch: java.sql.SQLException -> L90
                        goto L9f
                    L90:
                        r12 = move-exception
                        java.lang.RuntimeException r0 = new java.lang.RuntimeException
                        r1 = r0
                        r2 = r12
                        java.lang.String r2 = r2.toString()
                        r1.<init>(r2)
                        throw r0
                    L9f:
                        r0 = r6
                        if (r0 == 0) goto Lbb
                        r0 = r6
                        r0.close()     // Catch: java.sql.SQLException -> Lac
                        goto Lbb
                    Lac:
                        r12 = move-exception
                        java.lang.RuntimeException r0 = new java.lang.RuntimeException
                        r1 = r0
                        r2 = r12
                        java.lang.String r2 = r2.toString()
                        r1.<init>(r2)
                        throw r0
                    Lbb:
                        ret r11
                    Lbd:
                        return
                    */
                    throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.AnonymousClass1.run():void");
                }
            };
            cancelThread.start();
        }
    }

    public StatementImpl(ConnectionImpl c, String catalog) throws SQLException {
        this.charConverter = null;
        this.charEncoding = null;
        this.connection = null;
        this.connectionId = 0L;
        this.currentCatalog = null;
        this.eventSink = null;
        this.maxFieldSize = MysqlIO.getMaxBuf();
        this.pedantic = false;
        this.profileSQL = false;
        this.useUsageAdvisor = false;
        this.continueBatchOnError = false;
        if (c == null || c.isClosed()) {
            throw SQLError.createSQLException(Messages.getString("Statement.0"), SQLError.SQL_STATE_CONNECTION_NOT_OPEN);
        }
        this.connection = c;
        this.connectionId = this.connection.getId();
        this.currentCatalog = catalog;
        this.pedantic = this.connection.getPedantic();
        this.continueBatchOnError = this.connection.getContinueBatchOnError();
        if (!this.connection.getDontTrackOpenResources()) {
            this.connection.registerStatement(this);
        }
        if (this.connection != null) {
            this.maxFieldSize = this.connection.getMaxAllowedPacket();
            int defaultFetchSize = this.connection.getDefaultFetchSize();
            if (defaultFetchSize != 0) {
                setFetchSize(defaultFetchSize);
            }
        }
        if (this.connection.getUseUnicode()) {
            this.charEncoding = this.connection.getEncoding();
            this.charConverter = this.connection.getCharsetConverter(this.charEncoding);
        }
        boolean profiling = this.connection.getProfileSql() || this.connection.getUseUsageAdvisor();
        if (this.connection.getAutoGenerateTestcaseScript() || profiling) {
            int i = statementCounter;
            statementCounter = i + 1;
            this.statementId = i;
        }
        if (profiling) {
            this.pointOfOrigin = new Throwable();
            this.profileSQL = this.connection.getProfileSql();
            this.useUsageAdvisor = this.connection.getUseUsageAdvisor();
            this.eventSink = ProfileEventSink.getInstance(this.connection);
        }
        int maxRowsConn = this.connection.getMaxRows();
        if (maxRowsConn != -1) {
            setMaxRows(maxRowsConn);
        }
    }

    @Override // java.sql.Statement
    public synchronized void addBatch(String sql) throws SQLException {
        if (this.batchedArgs == null) {
            this.batchedArgs = new ArrayList();
        }
        if (sql != null) {
            this.batchedArgs.add(sql);
        }
    }

    /* JADX WARN: Code restructure failed: missing block: B:22:0x0065, code lost:
    
        if (r7 == null) goto L18;
     */
    /* JADX WARN: Code restructure failed: missing block: B:23:0x0068, code lost:
    
        r7.close();
     */
    /* JADX WARN: Code restructure failed: missing block: B:25:0x006f, code lost:
    
        if (r6 == null) goto L21;
     */
    /* JADX WARN: Code restructure failed: missing block: B:26:0x0072, code lost:
    
        r6.close();
     */
    /* JADX WARN: Code restructure failed: missing block: B:28:0x0061, code lost:
    
        throw r8;
     */
    @Override // java.sql.Statement
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public void cancel() throws java.sql.SQLException {
        /*
            r5 = this;
            r0 = r5
            boolean r0 = r0.isClosed
            if (r0 != 0) goto L7a
            r0 = r5
            com.mysql.jdbc.ConnectionImpl r0 = r0.connection
            if (r0 == 0) goto L7a
            r0 = r5
            com.mysql.jdbc.ConnectionImpl r0 = r0.connection
            r1 = 5
            r2 = 0
            r3 = 0
            boolean r0 = r0.versionMeetsMinimum(r1, r2, r3)
            if (r0 == 0) goto L7a
            r0 = 0
            r6 = r0
            r0 = 0
            r7 = r0
            r0 = r5
            com.mysql.jdbc.ConnectionImpl r0 = r0.connection     // Catch: java.lang.Throwable -> L5c
            com.mysql.jdbc.Connection r0 = r0.duplicate()     // Catch: java.lang.Throwable -> L5c
            r6 = r0
            r0 = r6
            java.sql.Statement r0 = r0.createStatement()     // Catch: java.lang.Throwable -> L5c
            r7 = r0
            r0 = r7
            java.lang.StringBuffer r1 = new java.lang.StringBuffer     // Catch: java.lang.Throwable -> L5c
            r2 = r1
            r2.<init>()     // Catch: java.lang.Throwable -> L5c
            java.lang.String r2 = "KILL QUERY "
            java.lang.StringBuffer r1 = r1.append(r2)     // Catch: java.lang.Throwable -> L5c
            r2 = r5
            com.mysql.jdbc.ConnectionImpl r2 = r2.connection     // Catch: java.lang.Throwable -> L5c
            com.mysql.jdbc.MysqlIO r2 = r2.getIO()     // Catch: java.lang.Throwable -> L5c
            long r2 = r2.getThreadId()     // Catch: java.lang.Throwable -> L5c
            java.lang.StringBuffer r1 = r1.append(r2)     // Catch: java.lang.Throwable -> L5c
            java.lang.String r1 = r1.toString()     // Catch: java.lang.Throwable -> L5c
            boolean r0 = r0.execute(r1)     // Catch: java.lang.Throwable -> L5c
            r0 = r5
            r1 = 1
            r0.wasCancelled = r1     // Catch: java.lang.Throwable -> L5c
            r0 = jsr -> L62
        L59:
            goto L7a
        L5c:
            r8 = move-exception
            r0 = jsr -> L62
        L60:
            r1 = r8
            throw r1
        L62:
            r9 = r0
            r0 = r7
            if (r0 == 0) goto L6e
            r0 = r7
            r0.close()
        L6e:
            r0 = r6
            if (r0 == 0) goto L78
            r0 = r6
            r0.close()
        L78:
            ret r9
        L7a:
            return
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.cancel():void");
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void checkClosed() throws SQLException {
        if (this.isClosed) {
            throw SQLError.createSQLException(Messages.getString("Statement.49"), SQLError.SQL_STATE_CONNECTION_NOT_OPEN);
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void checkForDml(String sql, char firstStatementChar) throws SQLException {
        if (firstStatementChar == 'I' || firstStatementChar == 'U' || firstStatementChar == 'D' || firstStatementChar == 'A' || firstStatementChar == 'C') {
            String noCommentSql = StringUtils.stripComments(sql, "'\"", "'\"", true, false, true, true);
            if (StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "INSERT") || StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "UPDATE") || StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "DELETE") || StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "DROP") || StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "CREATE") || StringUtils.startsWithIgnoreCaseAndWs(noCommentSql, "ALTER")) {
                throw SQLError.createSQLException(Messages.getString("Statement.57"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
            }
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void checkNullOrEmptyQuery(String sql) throws SQLException {
        if (sql == null) {
            throw SQLError.createSQLException(Messages.getString("Statement.59"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (sql.length() == 0) {
            throw SQLError.createSQLException(Messages.getString("Statement.61"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.Statement
    public synchronized void clearBatch() throws SQLException {
        if (this.batchedArgs != null) {
            this.batchedArgs.clear();
        }
    }

    @Override // java.sql.Statement
    public void clearWarnings() throws SQLException {
        this.warningChain = null;
    }

    @Override // java.sql.Statement, java.lang.AutoCloseable
    public void close() throws SQLException {
        realClose(true, true);
    }

    protected void closeAllOpenResults() {
        if (this.openResults != null) {
            for (ResultSetInternalMethods element : this.openResults) {
                try {
                    element.realClose(false);
                } catch (SQLException sqlEx) {
                    AssertionFailedException.shouldNotHappen(sqlEx);
                }
            }
            this.openResults.clear();
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    private ResultSetInternalMethods createResultSetUsingServerFetch(String sql) throws SQLException {
        java.sql.PreparedStatement prepareStatement = this.connection.prepareStatement(sql, this.resultSetType, this.resultSetConcurrency);
        prepareStatement.setFetchSize(this.fetchSize);
        if (this.maxRows > -1) {
            prepareStatement.setMaxRows(this.maxRows);
        }
        prepareStatement.execute();
        ResultSetInternalMethods rs = ((StatementImpl) prepareStatement).getResultSetInternal();
        rs.setStatementUsedForFetchingRows((PreparedStatement) prepareStatement);
        this.results = rs;
        return rs;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public boolean createStreamingResultSet() {
        return this.resultSetType == 1003 && this.resultSetConcurrency == 1007 && this.fetchSize == Integer.MIN_VALUE;
    }

    @Override // com.mysql.jdbc.Statement
    public void enableStreamingResults() throws SQLException {
        this.originalResultSetType = this.resultSetType;
        this.originalFetchSize = this.fetchSize;
        setFetchSize(Integer.MIN_VALUE);
        setResultSetType(MysqlErrorNumbers.ER_YES);
    }

    @Override // com.mysql.jdbc.Statement
    public void disableStreamingResults() throws SQLException {
        if (this.fetchSize == Integer.MIN_VALUE && this.resultSetType == 1003) {
            setFetchSize(this.originalFetchSize);
            setResultSetType(this.originalResultSetType);
        }
    }

    /* JADX WARN: Code restructure failed: missing block: B:117:0x0257, code lost:
    
        if (0 == 0) goto L99;
     */
    /* JADX WARN: Code restructure failed: missing block: B:118:0x025a, code lost:
    
        r20.cancel();
     */
    /* JADX WARN: Code restructure failed: missing block: B:120:0x0262, code lost:
    
        if (0 == 0) goto L102;
     */
    /* JADX WARN: Code restructure failed: missing block: B:121:0x0265, code lost:
    
        r0.setCatalog(null);
     */
    /* JADX WARN: Code restructure failed: missing block: B:123:0x0252, code lost:
    
        throw r25;
     */
    @Override // java.sql.Statement
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public boolean execute(java.lang.String r12) throws java.sql.SQLException {
        /*
            Method dump skipped, instructions count: 731
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.execute(java.lang.String):boolean");
    }

    @Override // java.sql.Statement
    public boolean execute(String sql, int returnGeneratedKeys) throws SQLException {
        boolean execute;
        if (returnGeneratedKeys == 1) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = this.connection.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    execute = execute(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return execute;
        }
        return execute(sql);
    }

    @Override // java.sql.Statement
    public boolean execute(String sql, int[] generatedKeyIndices) throws SQLException {
        boolean execute;
        if (generatedKeyIndices != null && generatedKeyIndices.length > 0) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = locallyScopedConn.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    execute = execute(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return execute;
        }
        return execute(sql);
    }

    @Override // java.sql.Statement
    public boolean execute(String sql, String[] generatedKeyNames) throws SQLException {
        boolean execute;
        if (generatedKeyNames != null && generatedKeyNames.length > 0) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = this.connection.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    execute = execute(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return execute;
        }
        return execute(sql);
    }

    @Override // java.sql.Statement
    public synchronized int[] executeBatch() throws SQLException {
        checkClosed();
        ConnectionImpl locallyScopedConn = this.connection;
        if (locallyScopedConn.isReadOnly()) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("Statement.34")).append(Messages.getString("Statement.35")).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (this.results != null && !locallyScopedConn.getHoldResultsOpenOverStatementClose()) {
            this.results.realClose(false);
        }
        synchronized (locallyScopedConn.getMutex()) {
            try {
                this.retrieveGeneratedKeys = true;
                int[] updateCounts = null;
                if (this.batchedArgs != null) {
                    int nbrCommands = this.batchedArgs.size();
                    this.batchedGeneratedKeys = new ArrayList(this.batchedArgs.size());
                    boolean multiQueriesEnabled = locallyScopedConn.getAllowMultiQueries();
                    if (locallyScopedConn.versionMeetsMinimum(4, 1, 1) && (multiQueriesEnabled || (locallyScopedConn.getRewriteBatchedStatements() && nbrCommands > 4))) {
                        int[] executeBatchUsingMultiQueries = executeBatchUsingMultiQueries(multiQueriesEnabled, nbrCommands);
                        this.retrieveGeneratedKeys = false;
                        clearBatch();
                        return executeBatchUsingMultiQueries;
                    }
                    updateCounts = new int[nbrCommands];
                    for (int i = 0; i < nbrCommands; i++) {
                        updateCounts[i] = -3;
                    }
                    SQLException sqlEx = null;
                    for (int commandIndex = 0; commandIndex < nbrCommands; commandIndex++) {
                        try {
                            updateCounts[commandIndex] = executeUpdate((String) this.batchedArgs.get(commandIndex), true);
                            getBatchedGeneratedKeys();
                        } catch (SQLException ex) {
                            updateCounts[commandIndex] = -3;
                            if (this.continueBatchOnError) {
                                sqlEx = ex;
                            } else {
                                int[] newUpdateCounts = new int[commandIndex];
                                System.arraycopy(updateCounts, 0, newUpdateCounts, 0, commandIndex);
                                throw new BatchUpdateException(ex.getMessage(), ex.getSQLState(), ex.getErrorCode(), newUpdateCounts);
                            }
                        }
                    }
                    if (sqlEx != null) {
                        throw new BatchUpdateException(sqlEx.getMessage(), sqlEx.getSQLState(), sqlEx.getErrorCode(), updateCounts);
                    }
                }
                return updateCounts != null ? updateCounts : new int[0];
            } finally {
                this.retrieveGeneratedKeys = false;
                clearBatch();
            }
        }
    }

    /*  JADX ERROR: JadxRuntimeException in pass: BlockProcessor
        jadx.core.utils.exceptions.JadxRuntimeException: Unreachable block: B:50:0x022d
        	at jadx.core.dex.visitors.blocks.BlockProcessor.checkForUnreachableBlocks(BlockProcessor.java:88)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.processBlocksTree(BlockProcessor.java:52)
        	at jadx.core.dex.visitors.blocks.BlockProcessor.visit(BlockProcessor.java:44)
        */
    private int[] executeBatchUsingMultiQueries(boolean r10, int r11) throws java.sql.SQLException {
        /*
            Method dump skipped, instructions count: 575
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.executeBatchUsingMultiQueries(boolean, int):int[]");
    }

    /* JADX WARN: Code restructure failed: missing block: B:102:0x0241, code lost:
    
        if (0 == 0) goto L94;
     */
    /* JADX WARN: Code restructure failed: missing block: B:103:0x0244, code lost:
    
        r19.cancel();
     */
    /* JADX WARN: Code restructure failed: missing block: B:105:0x024c, code lost:
    
        if (0 == 0) goto L97;
     */
    /* JADX WARN: Code restructure failed: missing block: B:106:0x024f, code lost:
    
        r0.setCatalog(null);
     */
    /* JADX WARN: Code restructure failed: missing block: B:108:0x023c, code lost:
    
        throw r24;
     */
    @Override // java.sql.Statement
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    public java.sql.ResultSet executeQuery(java.lang.String r13) throws java.sql.SQLException {
        /*
            Method dump skipped, instructions count: 665
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.executeQuery(java.lang.String):java.sql.ResultSet");
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void executeSimpleNonQuery(ConnectionImpl c, String nonQuery) throws SQLException {
        c.execSQL(this, nonQuery, -1, null, MysqlErrorNumbers.ER_YES, MysqlErrorNumbers.ER_DB_CREATE_EXISTS, false, this.currentCatalog, null, false).close();
    }

    @Override // java.sql.Statement
    public int executeUpdate(String sql) throws SQLException {
        return executeUpdate(sql, false);
    }

    /* JADX WARN: Code restructure failed: missing block: B:85:0x0192, code lost:
    
        if (0 == 0) goto L77;
     */
    /* JADX WARN: Code restructure failed: missing block: B:86:0x0195, code lost:
    
        r19.cancel();
     */
    /* JADX WARN: Code restructure failed: missing block: B:88:0x019d, code lost:
    
        if (0 == 0) goto L80;
     */
    /* JADX WARN: Code restructure failed: missing block: B:89:0x01a0, code lost:
    
        r0.setCatalog(null);
     */
    /* JADX WARN: Code restructure failed: missing block: B:91:0x018d, code lost:
    
        throw r23;
     */
    /*
        Code decompiled incorrectly, please refer to instructions dump.
        To view partially-correct code enable 'Show inconsistent code' option in preferences
    */
    protected int executeUpdate(java.lang.String r13, boolean r14) throws java.sql.SQLException {
        /*
            Method dump skipped, instructions count: 506
            To view this dump change 'Code comments level' option to 'DEBUG'
        */
        throw new UnsupportedOperationException("Method not decompiled: com.mysql.jdbc.StatementImpl.executeUpdate(java.lang.String, boolean):int");
    }

    @Override // java.sql.Statement
    public int executeUpdate(String sql, int returnGeneratedKeys) throws SQLException {
        int executeUpdate;
        if (returnGeneratedKeys == 1) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = locallyScopedConn.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    executeUpdate = executeUpdate(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return executeUpdate;
        }
        return executeUpdate(sql);
    }

    @Override // java.sql.Statement
    public int executeUpdate(String sql, int[] generatedKeyIndices) throws SQLException {
        int executeUpdate;
        if (generatedKeyIndices != null && generatedKeyIndices.length > 0) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = locallyScopedConn.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    executeUpdate = executeUpdate(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return executeUpdate;
        }
        return executeUpdate(sql);
    }

    @Override // java.sql.Statement
    public int executeUpdate(String sql, String[] generatedKeyNames) throws SQLException {
        int executeUpdate;
        if (generatedKeyNames != null && generatedKeyNames.length > 0) {
            checkClosed();
            ConnectionImpl locallyScopedConn = this.connection;
            synchronized (locallyScopedConn.getMutex()) {
                boolean readInfoMsgState = this.connection.isReadInfoMsgEnabled();
                locallyScopedConn.setReadInfoMsgEnabled(true);
                try {
                    executeUpdate = executeUpdate(sql);
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                } catch (Throwable th) {
                    locallyScopedConn.setReadInfoMsgEnabled(readInfoMsgState);
                    throw th;
                }
            }
            return executeUpdate;
        }
        return executeUpdate(sql);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public Calendar getCalendarInstanceForSessionOrNew() {
        if (this.connection != null) {
            return this.connection.getCalendarInstanceForSessionOrNew();
        }
        return new GregorianCalendar();
    }

    @Override // java.sql.Statement
    public java.sql.Connection getConnection() throws SQLException {
        return this.connection;
    }

    @Override // java.sql.Statement
    public int getFetchDirection() throws SQLException {
        return MysqlErrorNumbers.ER_HASHCHK;
    }

    @Override // java.sql.Statement
    public int getFetchSize() throws SQLException {
        return this.fetchSize;
    }

    @Override // java.sql.Statement
    public synchronized ResultSet getGeneratedKeys() throws SQLException {
        if (this.batchedGeneratedKeys == null) {
            return getGeneratedKeysInternal();
        }
        Field[] fields = {new Field("", "GENERATED_KEY", -5, 17)};
        fields[0].setConnection(this.connection);
        return ResultSetImpl.getInstance(this.currentCatalog, fields, new RowDataStatic(this.batchedGeneratedKeys), this.connection, this, false);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    /* JADX WARN: Type inference failed for: r0v25, types: [byte[], byte[][]] */
    public ResultSet getGeneratedKeysInternal() throws SQLException {
        Field[] fields = {new Field("", "GENERATED_KEY", -5, 17)};
        fields[0].setConnection(this.connection);
        ArrayList rowSet = new ArrayList();
        long beginAt = getLastInsertID();
        int numKeys = getUpdateCount();
        if (this.results != null) {
            String serverInfo = this.results.getServerInfo();
            if (numKeys > 0 && this.results.getFirstCharOfQuery() == 'R' && serverInfo != null && serverInfo.length() > 0) {
                numKeys = getRecordCountFromInfo(serverInfo);
            }
            if (beginAt > 0 && numKeys > 0) {
                for (int i = 0; i < numKeys; i++) {
                    long j = beginAt;
                    beginAt = j + 1;
                    rowSet.add(new ByteArrayRow(new byte[]{Long.toString(j).getBytes()}));
                }
            }
        }
        return ResultSetImpl.getInstance(this.currentCatalog, fields, new RowDataStatic(rowSet), this.connection, this, false);
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public int getId() {
        return this.statementId;
    }

    public long getLastInsertID() {
        return this.lastInsertId;
    }

    public long getLongUpdateCount() {
        if (this.results == null || this.results.reallyResult()) {
            return -1L;
        }
        return this.updateCount;
    }

    @Override // java.sql.Statement
    public int getMaxFieldSize() throws SQLException {
        return this.maxFieldSize;
    }

    @Override // java.sql.Statement
    public int getMaxRows() throws SQLException {
        if (this.maxRows <= 0) {
            return 0;
        }
        return this.maxRows;
    }

    @Override // java.sql.Statement
    public boolean getMoreResults() throws SQLException {
        return getMoreResults(1);
    }

    @Override // java.sql.Statement
    public boolean getMoreResults(int current) throws SQLException {
        if (this.results == null) {
            return false;
        }
        ResultSetInternalMethods nextResultSet = this.results.getNextResultSet();
        switch (current) {
            case 1:
                if (this.results != null) {
                    this.results.close();
                    this.results.clearNextResult();
                    break;
                }
                break;
            case 2:
                if (!this.connection.getDontTrackOpenResources()) {
                    this.openResults.add(this.results);
                }
                this.results.clearNextResult();
                break;
            case 3:
                if (this.results != null) {
                    this.results.close();
                    this.results.clearNextResult();
                }
                closeAllOpenResults();
                break;
            default:
                throw SQLError.createSQLException(Messages.getString("Statement.19"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.results = nextResultSet;
        if (this.results == null) {
            this.updateCount = -1L;
            this.lastInsertId = -1L;
        } else if (this.results.reallyResult()) {
            this.updateCount = -1L;
            this.lastInsertId = -1L;
        } else {
            this.updateCount = this.results.getUpdateCount();
            this.lastInsertId = this.results.getUpdateID();
        }
        return this.results != null && this.results.reallyResult();
    }

    @Override // java.sql.Statement
    public int getQueryTimeout() throws SQLException {
        return this.timeoutInMillis / MysqlErrorNumbers.ER_HASHCHK;
    }

    private int getRecordCountFromInfo(String serverInfo) {
        StringBuffer recordsBuf = new StringBuffer();
        char c = 0;
        int length = serverInfo.length();
        int i = 0;
        while (i < length) {
            c = serverInfo.charAt(i);
            if (Character.isDigit(c)) {
                break;
            }
            i++;
        }
        recordsBuf.append(c);
        while (true) {
            i++;
            if (i >= length) {
                break;
            }
            c = serverInfo.charAt(i);
            if (!Character.isDigit(c)) {
                break;
            }
            recordsBuf.append(c);
        }
        int recordsCount = Integer.parseInt(recordsBuf.toString());
        StringBuffer duplicatesBuf = new StringBuffer();
        while (i < length) {
            c = serverInfo.charAt(i);
            if (Character.isDigit(c)) {
                break;
            }
            i++;
        }
        duplicatesBuf.append(c);
        while (true) {
            i++;
            if (i >= length) {
                break;
            }
            char c2 = serverInfo.charAt(i);
            if (!Character.isDigit(c2)) {
                break;
            }
            duplicatesBuf.append(c2);
        }
        int duplicatesCount = Integer.parseInt(duplicatesBuf.toString());
        return recordsCount - duplicatesCount;
    }

    @Override // java.sql.Statement
    public ResultSet getResultSet() throws SQLException {
        if (this.results == null || !this.results.reallyResult()) {
            return null;
        }
        return this.results;
    }

    @Override // java.sql.Statement
    public int getResultSetConcurrency() throws SQLException {
        return this.resultSetConcurrency;
    }

    @Override // java.sql.Statement
    public int getResultSetHoldability() throws SQLException {
        return 1;
    }

    protected ResultSetInternalMethods getResultSetInternal() {
        return this.results;
    }

    @Override // java.sql.Statement
    public int getResultSetType() throws SQLException {
        return this.resultSetType;
    }

    @Override // java.sql.Statement
    public int getUpdateCount() throws SQLException {
        int truncatedUpdateCount;
        if (this.results == null || this.results.reallyResult()) {
            return -1;
        }
        if (this.results.getUpdateCount() > 2147483647L) {
            truncatedUpdateCount = Integer.MAX_VALUE;
        } else {
            truncatedUpdateCount = (int) this.results.getUpdateCount();
        }
        return truncatedUpdateCount;
    }

    @Override // java.sql.Statement
    public SQLWarning getWarnings() throws SQLException {
        checkClosed();
        if (this.connection != null && !this.connection.isClosed() && this.connection.versionMeetsMinimum(4, 1, 0)) {
            SQLWarning pendingWarningsFromServer = SQLError.convertShowWarningsToSQLWarnings(this.connection);
            if (this.warningChain != null) {
                this.warningChain.setNextWarning(pendingWarningsFromServer);
            } else {
                this.warningChain = pendingWarningsFromServer;
            }
            return this.warningChain;
        }
        return this.warningChain;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void realClose(boolean calledExplicitly, boolean closeOpenResults) throws SQLException {
        if (this.isClosed) {
            return;
        }
        if (this.useUsageAdvisor && !calledExplicitly) {
            String message = new StringBuffer().append(Messages.getString("Statement.63")).append(Messages.getString("Statement.64")).toString();
            this.eventSink.consumeEvent(new ProfilerEvent((byte) 0, "", this.currentCatalog, this.connectionId, getId(), -1, System.currentTimeMillis(), 0L, Constants.MILLIS_I18N, (String) null, this.pointOfOrigin, message));
        }
        if (this.results != null) {
            if (closeOpenResults) {
                closeOpenResults = !this.holdResultsOpenOverClose;
            }
            if (closeOpenResults && this.connection != null && !this.connection.getHoldResultsOpenOverStatementClose()) {
                try {
                    this.results.close();
                } catch (Exception e) {
                }
                closeAllOpenResults();
            }
        }
        if (this.connection != null) {
            if (this.maxRowsChanged) {
                this.connection.unsetMaxRows(this);
            }
            if (!this.connection.getDontTrackOpenResources()) {
                this.connection.unregisterStatement(this);
            }
        }
        this.isClosed = true;
        this.results = null;
        this.connection = null;
        this.warningChain = null;
        this.openResults = null;
        this.batchedGeneratedKeys = null;
        this.cancelTimeoutMutex = null;
    }

    @Override // java.sql.Statement
    public void setCursorName(String name) throws SQLException {
    }

    @Override // java.sql.Statement
    public void setEscapeProcessing(boolean enable) throws SQLException {
        this.doEscapeProcessing = enable;
    }

    @Override // java.sql.Statement
    public void setFetchDirection(int direction) throws SQLException {
        switch (direction) {
            case MysqlErrorNumbers.ER_HASHCHK /* 1000 */:
            case MysqlErrorNumbers.ER_NISAMCHK /* 1001 */:
            case MysqlErrorNumbers.ER_NO /* 1002 */:
                return;
            default:
                throw SQLError.createSQLException(Messages.getString("Statement.5"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    @Override // java.sql.Statement
    public void setFetchSize(int rows) throws SQLException {
        if ((rows < 0 && rows != Integer.MIN_VALUE) || (this.maxRows != 0 && this.maxRows != -1 && rows > getMaxRows())) {
            throw SQLError.createSQLException(Messages.getString("Statement.7"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.fetchSize = rows;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public void setHoldResultsOpenOverClose(boolean holdResultsOpenOverClose) {
        this.holdResultsOpenOverClose = holdResultsOpenOverClose;
    }

    @Override // java.sql.Statement
    public void setMaxFieldSize(int max) throws SQLException {
        if (max < 0) {
            throw SQLError.createSQLException(Messages.getString("Statement.11"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        int maxBuf = this.connection != null ? this.connection.getMaxAllowedPacket() : MysqlIO.getMaxBuf();
        if (max > maxBuf) {
            throw SQLError.createSQLException(Messages.getString("Statement.13", new Object[]{Constants.longValueOf(maxBuf)}), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.maxFieldSize = max;
    }

    @Override // java.sql.Statement
    public void setMaxRows(int max) throws SQLException {
        if (max > 50000000 || max < 0) {
            throw SQLError.createSQLException(new StringBuffer().append(Messages.getString("Statement.15")).append(max).append(" > ").append(50000000).append(".").toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        if (max == 0) {
            max = -1;
        }
        this.maxRows = max;
        this.maxRowsChanged = true;
        if (this.maxRows == -1) {
            this.connection.unsetMaxRows(this);
            this.maxRowsChanged = false;
        } else {
            this.connection.maxRowsChanged(this);
        }
    }

    @Override // java.sql.Statement
    public void setQueryTimeout(int seconds) throws SQLException {
        if (seconds < 0) {
            throw SQLError.createSQLException(Messages.getString("Statement.21"), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
        this.timeoutInMillis = seconds * MysqlErrorNumbers.ER_HASHCHK;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void setResultSetConcurrency(int concurrencyFlag) {
        this.resultSetConcurrency = concurrencyFlag;
    }

    /* JADX INFO: Access modifiers changed from: package-private */
    public void setResultSetType(int typeFlag) {
        this.resultSetType = typeFlag;
    }

    /* JADX INFO: Access modifiers changed from: protected */
    /* JADX WARN: Multi-variable type inference failed */
    public void getBatchedGeneratedKeys(java.sql.Statement batchedStatement) throws SQLException {
        if (this.retrieveGeneratedKeys) {
            ResultSet rs = null;
            try {
                rs = batchedStatement.getGeneratedKeys();
                while (rs.next()) {
                    this.batchedGeneratedKeys.add(new byte[]{rs.getBytes(1)});
                }
                if (rs != null) {
                    rs.close();
                }
            } catch (Throwable th) {
                if (rs != null) {
                    rs.close();
                }
                throw th;
            }
        }
    }

    /* JADX WARN: Multi-variable type inference failed */
    protected void getBatchedGeneratedKeys() throws SQLException {
        if (this.retrieveGeneratedKeys) {
            ResultSet rs = null;
            try {
                rs = getGeneratedKeysInternal();
                while (rs.next()) {
                    this.batchedGeneratedKeys.add(new byte[]{rs.getBytes(1)});
                }
                if (rs != null) {
                    rs.close();
                }
            } catch (Throwable th) {
                if (rs != null) {
                    rs.close();
                }
                throw th;
            }
        }
    }

    private boolean useServerFetch() throws SQLException {
        return this.connection.isCursorFetchEnabled() && this.fetchSize > 0 && this.resultSetConcurrency == 1007 && this.resultSetType == 1003;
    }

    @Override // java.sql.Statement
    public synchronized boolean isClosed() throws SQLException {
        return this.isClosed;
    }

    @Override // java.sql.Statement
    public boolean isPoolable() throws SQLException {
        return this.isPoolable;
    }

    @Override // java.sql.Statement
    public void setPoolable(boolean poolable) throws SQLException {
        this.isPoolable = poolable;
    }

    @Override // java.sql.Wrapper
    public boolean isWrapperFor(Class iface) throws SQLException {
        checkClosed();
        return iface.isInstance(this);
    }

    @Override // java.sql.Wrapper
    public Object unwrap(Class iface) throws SQLException {
        try {
            return Util.cast(iface, this);
        } catch (ClassCastException e) {
            throw SQLError.createSQLException(new StringBuffer().append("Unable to unwrap to ").append(iface.toString()).toString(), SQLError.SQL_STATE_ILLEGAL_ARGUMENT);
        }
    }

    /* JADX INFO: Access modifiers changed from: protected */
    public int findStartOfStatement(String sql) {
        int statementStartPos = 0;
        if (StringUtils.startsWithIgnoreCaseAndWs(sql, "/*")) {
            int statementStartPos2 = sql.indexOf("*/");
            if (statementStartPos2 == -1) {
                statementStartPos = 0;
            } else {
                statementStartPos = statementStartPos2 + 2;
            }
        } else if (StringUtils.startsWithIgnoreCaseAndWs(sql, "--") || StringUtils.startsWithIgnoreCaseAndWs(sql, "#")) {
            statementStartPos = sql.indexOf(10);
            if (statementStartPos == -1) {
                statementStartPos = sql.indexOf(13);
                if (statementStartPos == -1) {
                    statementStartPos = 0;
                }
            }
        }
        return statementStartPos;
    }
}
